/*
 * Created on Aug 13, 2003
 */
package isac.bridge;

/**
 * This class handles a list of all clients which connect to the
 * Bridge.
 * @author rgradisc
 */

import java.io.PrintWriter;
import java.util.Map;
import java.util.TreeMap;

public class ClientList {
  //Clients are saved in a map
  private Map map;

  /**
   * Constructor: create a new ClientList
   */
  public ClientList() {
    map = new TreeMap(); 
  }

  /**
   * Add a client to this clientlist
   * @param id the id of the new client 
   * @param pw a Printwriter to communicate with the new client
   */
  public void addClient(int id, PrintWriter pw) {
    map.put(new Integer(id), pw);
  }

  /**
   * Get the PrintWriter associated to a client
   * @param id ID of client
   * @return PrintWriter for this client, null if not in list
   */
  public PrintWriter getPrintWriterOfClient(int id) {
    return (PrintWriter) map.get(new Integer(id));
  }

  /**
   * Remove a client from the list
   * @param id ID of client to be removed
   */
  public void removeClient(int id) {
    map.remove(new Integer(id));    
  }
}
