/****************************************************************** 
* Copyright (c) 2003, Mario Hochreiter, Student of 
* Software Engineering at FH-Hagenberg, Austria. 
* Project member of the isac team at the Institute for 
* Software-Technologie, Graz University of Technology, Austria. 
* 
* Use is subject to license terms.
******************************************************************/

package isac.gui.browser;

import isac.gui.util.Hierarchy;
import isac.gui.util.HierarchyNode;

import java.util.List;

import javax.swing.event.TreeModelListener;
import javax.swing.tree.TreeModel;
import javax.swing.tree.TreePath;

/**
 * TreeModel for the ExampleBrowser 
 * @author Mario Hochreiter
 * @version 1.0
 *
 */
public class BrowserTreeModel implements TreeModel {
  protected Hierarchy hierarchy;

  public BrowserTreeModel(Hierarchy hierarchy) {
    this.hierarchy = hierarchy;
  }

  public Object getRoot() {
    return hierarchy.getRoot();    
  }

  public int getChildCount(Object parent) {
    HierarchyNode parNode = (HierarchyNode)parent;
    List childs = hierarchy.getChilds(parNode);
    return childs.size();
  }

  public boolean isLeaf(Object node) {
    HierarchyNode exNode = (HierarchyNode)node;
    List childs = hierarchy.getChilds(exNode);
    return childs == null; 
  }

  public void addTreeModelListener(TreeModelListener l) {
    //TODO implement
  }

  public void removeTreeModelListener(TreeModelListener l) {

  }

  public Object getChild(Object parent, int index) {
    return hierarchy.getChild((HierarchyNode)parent, index);
  }

  public int getIndexOfChild(Object parent, Object child) {
    return hierarchy.getIndexOfChild((HierarchyNode)parent, (HierarchyNode)child);
  }

  public void valueForPathChanged(TreePath path, Object newValue) {
    //TODO implement
  }
}
