/****************************************************************** 
* Copyright (c) 2003, Mario Hochreiter, Student of 
* Software Engineering at FH-Hagenberg, Austria. 
* Project member of the isac team at the Institute for 
* Software-Technologie, Graz University of Technology, Austria. 
* 
* Use is subject to license terms.
******************************************************************/

package isac.gui.browser.method;

import isac.gui.browser.ContentPanel;
import isac.gui.browser.TabPanel;
import isac.gui.util.Hierarchy;
import isac.gui.util.MethodNode;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.JFrame;
import javax.swing.tree.TreePath;

/**
 * @author Mario Hochreiter
 * @version 0.1
 *
 */
public class MethodBrowserPanel extends TabPanel {
  
  public MethodBrowserPanel(JFrame root, Hierarchy hierarchy) {
    super(root, hierarchy);
    this.initMouseListener();
  }
  
  protected void initMouseListener() {
    ml = new MouseAdapter() {
      public void mousePressed(MouseEvent e) {
        int selRow = viewTree.getRowForLocation(e.getX(), e.getY());
        TreePath selPath = viewTree.getPathForLocation(e.getX(), e.getY());
        if (selRow != -1) {
          if (e.getClickCount() == 2) {
            MethodNode selNode = (MethodNode)selPath.getLastPathComponent();
            ContentPanel cp = root.getContentPanel();
            if (selNode.getContentref() != null) {
              cp.setContent("met", selNode.getContentref());
            } else if (selNode.getNo() != null) {
              cp.setContent("met", selNode.getNo());
            }
            root.showContentFrame();
          }
        }
      }
    };
    viewTree.addMouseListener(ml);
  }
}
