/****************************************************************** 
* Copyright (c) 2003, Mario Hochreiter, Student of 
* Software Engineering at FH-Hagenberg, Austria. 
* Project member of the isac team at the Institute for 
* Software-Technologie, Graz University of Technology, Austria. 
* 
* Use is subject to license terms.
******************************************************************/

package isac.gui.calcheadviews;

import isac.gui.util.SpringUtilities;
import isac.util.formulae.CalcHead;

import java.util.Locale;
import java.util.StringTokenizer;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JTextPane;
import javax.swing.SpringLayout;

import org.apache.log4j.Logger;

/**
 * @author Mario Hochreiter
 * @version 1.0
 *
 */
public class SimpleCalcHeadView extends CalcHeadView {
	static Logger logger = Logger.getLogger(SimpleCalcHeadView.class.getName());

  public SimpleCalcHeadView(Locale locale, CalcHead ch) {
    super(locale);
    this.init(); 
    this.fillTextFieldsFromCalcHead(ch);
  }
  
  private void init() {
    this.buildTextFields();
    this.buildLabels();
    this.layoutComponents();  
  }   

  protected void layoutComponents() {
    this.setLayout(new SpringLayout());
    this.add(labelGiven);
    this.add(txtGiven);   
    SpringUtilities.makeCompactGrid(this,
                             1, 2, //rows, cols
                             5, 5, //initialX, initialY
                             5, 5);//xPad, yPad
  }

  protected void buildLabels() {
    labelGiven = new JLabel(resBundle.getString("solve"));   
  }

  protected void buildTextFields() {
    txtGiven = new JTextPane();
    txtGiven.setBorder(BorderFactory.createEtchedBorder()); 
  }

  public void fillTextFieldsFromCalcHead(CalcHead ch) {
    clearTextFields();
    txtGiven.setText(getSimpleSolveString(ch));
    
  }
  
  private String getSimpleSolveString(CalcHead ch) {
  	StringBuffer sb = new StringBuffer();
  	StringTokenizer st = new StringTokenizer(ch.getGiven().toSMLString(), ",");
    StringBuffer eq = new StringBuffer(st.nextToken());
    String equation = eq.substring(eq.indexOf("(") + 1, eq.indexOf(")"));
    logger.info(equation);
    Character c = new Character('"');
    StringTokenizer st2 = new StringTokenizer(st.nextToken(), " " + c.toString());
    logger.info(st2.nextToken());
  	sb.append("(").append(equation).append(", ").append(st2.nextToken()).append(")");
  	logger.info(sb.toString());
  	return sb.toString();
  }

  /**
   * @param ch CalcHead from wich the data is read to fill out the text fields
   */
  public void fillCalcHeadFromTextFields(CalcHead ch) {
    /* theory ; method ; problem */
    
//    //given
//    String given = txtGiven.getText();
//    CalcHeadItemList givenList = new CalcHeadItemList();
//    CalcHeadItem givenItem = new CalcHeadItem();
//    givenItem.setText(given);
//    givenList.addItem(givenItem);
//    ch.setGiven(givenList);
//    
//    //where
//    String where = txtWhere.getText();
//    CalcHeadItemList whereList = new CalcHeadItemList();
//    CalcHeadItem whereItem = new CalcHeadItem();
//    whereItem.setText(where);
//    whereList.addItem(whereItem);
//    ch.setWhere(whereList);
//    
//    //find
//    String find = txtFind.getText();
//    CalcHeadItemList findList = new CalcHeadItemList();
//    CalcHeadItem findItem = new CalcHeadItem();
//    findItem.setText(find);
//    findList.addItem(findItem);
//    ch.setFind(findList);
//    
//    //relate
//    String relate = txtRelate.getText();
//    CalcHeadItemList relateList = new CalcHeadItemList();
//    CalcHeadItem relateItem = new CalcHeadItem();
//    relateItem.setText(relate);
//    relateList.addItem(relateItem);
//    ch.setRelate(relateList);
    }

}
