/*
 * Created on Nov 6, 2003
 *
 */

package isac.util;

import isac.util.formulae.CalcHeadSimpleID;
import isac.util.formulae.Position;

/**
 * @author Richard Gradischnegg
 * 
 * This class is used to wrap the objects produced by the XMLDigestParser from
 * the XML-output of the kernel
 */
public class ResponseWrapper {

	////WN041105 _all_ possible objects on _first_ level of xml-objects
	//in each object
	private CalcHeadSimpleID calcID_;

	/**
	 * in some objects, causes problems with CALCCHANGED, where Positions are
	 * _not_ on first level: these require different tags UNCHANGED etc.
	 * 
	 * @see isac.util.parser.XMLParserDigest addObjectCreate("/POSITION"
	 */
//	private Position position_;

	//contains the data
	private Object response_;

	public Object getResponse() {
		return response_;
	}

	public void setResponse(Object o) {
		response_ = o;
	}

	public int getCalcID() {
		if (calcID_ != null) {
			return Integer.parseInt(calcID_.getID());
		} else {
			return 0;
		}
	}

	public void setCalcID(CalcHeadSimpleID idObject) {
		//System.out.println("<<<<"+idObject+"||||"+idObject.getID()+">>>>");
		this.calcID_ = idObject;
	}

}