/*
 * Created on Sep 19, 2003
 */
package isac.util.formulae;

import java.io.Serializable;
import java.util.Iterator;
import java.util.Vector;

/**
 * Used for field storing IDs in the CalcHead object TODO: What is the
 * difference between this and CalcHeadItemList? Merge them?
 * 
 * WN040930 made ProblemID + MethodID subclasses of this; attempt to replace
 * CalcHeadCompoundID wherever possible: stopped when Formalization and CalcHead
 * could not be handled anymore (but a respective flaw is corrected already?!)
 * 
 * @see <isac.util.formulae.CalcHead>, <isac.gui.calcheadviews.CalcHeadView>
 *  
 */
public class CalcHeadCompoundID implements Serializable {

  protected Vector id = new Vector();

  public Vector getID() {
    return id;
  }
  
  public void setID(Vector v) {
  	id = v;
  }

  public void addString(String id) {
    this.id.add(id.trim());
  }
  
  /** Format the object in a way that the bridge can handle it 
  *  @return SML representation (is NOT a Java-String)
  */
  public String toSMLString() {
    //return "[\"" + StringUtil.join(ids, "\",\"") + "\"]";
    if (id.isEmpty()) {
      return "[]";
    } else {
      StringBuffer sb = new StringBuffer();
      Iterator it = id.iterator();
      sb.append("[");      
      while (it.hasNext()) {   
      	sb.append("\"");     
        sb.append(it.next());
		sb.append("\",");
      }
	  sb.deleteCharAt(sb.length()-1); // remove last ","
      sb.append("]");
      return sb.toString();
    }
  }
  
  public String toString(){
	String content="<KEY>\n";//TODO.WN041001 drop that XML
	Iterator vectit = id.iterator();
	while(vectit.hasNext()){
		content+="<ID>"+vectit.next()+"</ID>\n";//TODO.WN041001 drop that XML
	}
	content+="</KEY>\n";//TODO.WN041001 drop that XML
  		
	return content;
  }

  public boolean equals(Object o) {
  	if (o instanceof CalcHeadCompoundID)
  		return this.getID().equals(((CalcHeadCompoundID)o).getID());
  	else
  		return false;
  }
  
}
