/*
 * Created on Feb 22, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package isac.util.usersettings;

/**
 * @author Alan Krempler
 *
 * The UserModel is a class to gather statistics about one user's interaction with the system.
 * Statistis are gathered per user and per interactional context.
 */
public class UserModel {
	
//	special value for retrieving the statistics regardless of the dialog atom used in the interaction
 public static final int DIALOG_ATOM_ANY = 0;
	
	// counter for identifying pending interactions 
	private static int interaction_nr_ = 1;
	
	/**
	 * @param item_id	ID of the item being queried, a tactic for example
	 * @param dialog_atom	ID of the interactional context
	 * use DIALOG_ATOM_ANY if asking for statistics for all dialog atoms
	 * @return	count of previously recorded interactions with this item
	 */
	public int getTouchedCount(int item_id, int dialog_atom) {
		// FIXME: returning dummy value in absence of valid statistics
		return 0;
	}
	
	/**
	 * @param item_id	ID of the item being queried, a tactic for example
	 * @param dialog_atom	ID of the interactional context
	 * use DIALOG_ATOM_ANY if asking for statistics for all dialog atoms
	 * @return	count of previously recorded successful interactions with this item
	 */
	public int getSuccessCount(int item_id, int dialog_atom) {
		// FIXME: returning dummy value in absence of valid statistics
		return 0;
	}
	
	/**
	 * @param item_id	ID of the item being queried, a tactic for example
	 * @param dialog_atom	ID of the interactional context
	 * use DIALOG_ATOM_ANY if asking for statistics for all dialog atoms
	 * @return	time of last recorded interaction with this item
	 */
	public java.util.Date getTouchedLast(int item_id, int dialog_atom) {
		// FIXME: returning dummy value in absence of valid statistics
		return new java.util.Date();
	}
	
	/**
	 * @param item_id	ID of the item being queried, a tactic for example
	 * @param dialog_atom	ID of the interactional context
	 * use DIALOG_ATOM_ANY if asking for statistics for all dialog atoms
	 * @return	time of last recorded successful interaction with this item
	 */
	public java.util.Date getSuccessLast(int item_id, int dialog_atom) {
		// FIXME: returning dummy value in absence of valid statistics
		return new java.util.Date();
	}
	
	/**
	 * @param item_id	ID of the item being queried, a tactic for example
	 * @param dialog_atom	ID of the interactional context
	 * use DIALOG_ATOM_ANY if asking for statistics for all dialog atoms
	 * @return	average time (seconds) spent in interactions with this item
	 */
	public int getTimeSpentAvg(int item_id, int dialog_atom) {
		// FIXME: returning dummy value in absence of valid statistics
		return 0;
	}
	
	/**
	 * @param item_id	ID of the item being queried, a tactic for example
	 * @param dialog_atom	ID of the interactional context
	 * use DIALOG_ATOM_ANY if asking for statistics for all dialog atoms
	 * @return	maximum time (seconds) spent in interactions with this item
	 */
	public int getTimeSpentMax(int item_id, int dialog_atom) {
		// FIXME: returning dummy value in absence of valid statistics
		return 0;
	}
	
	/**
	 * @param item_id	ID of the item being queried, a tactic for example
	 * @param dialog_atom	ID of the interactional context
	 * use DIALOG_ATOM_ANY if asking for statistics for all dialog atoms
	 * @return	standard deviation of  time spent in interactions with this item
	 */
	public float getTimeSpentStddev(int item_id, int dialog_atom) {
		// FIXME: returning dummy value in absence of valid statistics
		return 0;
	}

  /**
   * Mark the beginning of an interaction with an item. 
	 * @param item_id	ID of the item being acted upon, a tactic for example
	 * @param dialog_atom	ID of the interactional context
	 * @return unique number to indentify the end of the transaction 
  */
public int startInteraction(int item_id, int dialog_atom) {
  	// FIXME: insert code to record statistics
  	
  	// record timestamp
  	// new java.util.Date(); ...
  	
  	// save in static vector of currently open interactions
  	// ...
  	
  	return interaction_nr_++;
  }

  /**
   * Mark the end of an interaction with an item. 
	 * @param interaction_id	ID of the interaction returned from the call to {@link # startInteraction() }
	 * @param success	information about the success of the interaction
	 * @return false in case of failure - no matching start could be found, true in case of success
  */
public boolean endInteraction(int interaction_id, int success) {
	// FIXME: insert code to record statistics
  	
	// record end  timestamp
	// new java.util.Date(); ...
  	
  // add to statistics
  	
	// delete from static vector of currently open interactions
	// ...
  	
	return true;
  }

}
