(* testexamples for Poly, polynomials
   *)
(*
trace_rewrite:=false; 
use"kbtest/poly.sml";
trace_rewrite:=true;
*)

(*---------------------------------------------------------------------*)
(*----------------------- Bsple aus Schalk I --------------------------*)
(*---------------------------------------------------------------------*)

(*Schalk I p.63 No.267b*)
 val t = str2term
 	     "(5*x^^^2 + 3) * (2*x^^^7 + 3) - (3*x^^^5 + 8) * (6*x^^^4 - 1)";
 val Some (t,_) = rewrite_set_ thy false make_polynomial t;
 term2str t;
if (term2str t) = 
"17 + 15 * x ^^^ 2 + -48 * x ^^^ 4 + 3 * x ^^^ 5 + 6 * x ^^^ 7 + -8 * x ^^^ 9"
then ()
else raise error "poly.sml: diff.behav. in make_polynomial";

(*Schalk I p.63 No.275b*)
 val t = str2term
 	     "(3*x^^^2 - 2*x*y + y^^^2) * (x^^^2 - 2*y^^^2)";
 val Some (t,_) = rewrite_set_ thy false make_polynomial t;
 term2str t;
if (term2str t) = 
"3 * x ^^^ 4 + -2 * x ^^^ 3 * y + -5 * x ^^^ 2 * y ^^^ 2 + \
\4 * x * y ^^^ 3 +\n-2 * y ^^^ 4"
then ()
else raise error "poly.sml: diff.behav. in make_polynomial";

(*Schalk I p.63 No.279b*)
 val t = str2term
 	     "(x-a)*(x-b)*(x-c)*(x-d)";
 val Some (t,_) = rewrite_set_ thy false make_polynomial t;
 term2str t;
(* Richtig! *)
if (term2str t) = 
"a * b * c * d + -1 * a * b * c * x + -1 * a * b * d * x + a * b * x ^^^ 2 +\n-1 * a * c * d * x +\na * c * x ^^^ 2 +\na * d * x ^^^ 2 +\n-1 * a * x ^^^ 3 +\n-1 * b * c * d * x +\nb * c * x ^^^ 2 +\nb * d * x ^^^ 2 +\n-1 * b * x ^^^ 3 +\nc * d * x ^^^ 2 +\n-1 * c * x ^^^ 3 +\n-1 * d * x ^^^ 3 +\nx ^^^ 4"
then ()
else raise error "poly.sml: diff.behav. in make_polynomial";

(*Schalk I p.63 No.291*)
 val t = str2term
 "(5+96*x^^^3+8*x*(-4+(7- 3*x)*4*x))*(5*(2- 3*x)- (-15*x*(-8*x- 5)))";
 val Some (t,_) = rewrite_set_ thy false make_polynomial t;
 term2str t;
if (term2str t) = 
"50 + -770 * x + 4520 * x ^^^ 2 + -16320 * x ^^^ 3 + -26880 * x ^^^ 4"
then ()
else raise error "poly.sml: diff.behav. in make_polynomial";

(*Schalk I p.64 No.295c*)
 val t = str2term
 "(13*a^^^4*b^^^9*c - 12*a^^^3*b^^^6*c^^^9)^^^2";
 val Some (t,_) = rewrite_set_ thy false make_polynomial t;
 term2str t;
if (term2str t) = 
"169 * a ^^^ 8 * b ^^^ 18 * c ^^^ 2 + -312 * a ^^^ 7 * b ^^^ 15 * c ^^^ 10\
\ +\n144 * a ^^^ 6 * b ^^^ 12 * c ^^^ 18"
then ()
else raise error "poly.sml: diff.behav. in make_polynomial";

(*Schalk I p.64 No.299a*)
 val t = str2term
 "(x - y)*(x + y)";
 val Some (t,_) = rewrite_set_ thy false make_polynomial t;
 term2str t;
if (term2str t) = 
"x ^^^ 2 + -1 * y ^^^ 2"
then ()
else raise error "poly.sml: diff.behav. in make_polynomial";

(*Schalk I p.64 No.300c*)
 val t = str2term
 "(3*x^^^2*y - 1)*(3*x^^^2*y + 1)";
 val Some (t,_) = rewrite_set_ thy false make_polynomial t;
 term2str t;
if (term2str t) = 
"-1 + 9 * x ^^^ 4 * y ^^^ 2"
then ()
else raise error "poly.sml: diff.behav. in make_polynomial";

(*Schalk I p.64 No.302*)
 val t = str2term
 "(13*x^^^2 + 5)*(13*x^^^2 - 5) - (5*x^^^2 + 3)*(5*x^^^2 - 3) - (12*x^^^2 + 4)*(12*x^^^2 - 4)";
 val Some (t,_) = rewrite_set_ thy false make_polynomial t;
 term2str t;
if (term2str t) = 
"0"
then ()
else raise error "poly.sml: diff.behav. in make_polynomial";
(* Bei Berechnung sollte 3 mal real_plus_minus_binom1_p aus expand_poly verwendet werden *)


(*Schalk I p.64 No.306a*)
 val t = str2term
 "((x^^^2 + 1)*(x^^^2 - 1))^^^2";
 val Some (t,_) = rewrite_set_ thy false make_polynomial t;
 term2str t;
if (term2str t) = 
"1 + -2 * x ^^^ 4 + x ^^^ 8"
then ()
else raise error "poly.sml: diff.behav. in make_polynomial";

(*Schalk I p.64 No.296a*)
 val t = str2term
 "(x - a)^^^3";
 val Some (t,_) = rewrite_set_ thy false make_polynomial t;
 term2str t;
if (term2str t) = 
"-1 * a ^^^ 3 + 3 * a ^^^ 2 * x + -3 * a * x ^^^ 2 + x ^^^ 3"
then ()
else raise error "poly.sml: diff.behav. in make_polynomial";

(*Schalk I p.64 No.296c*)
 val t = str2term
 "(-3*x - 4*y)^^^3";
 val Some (t,_) = rewrite_set_ thy false make_polynomial t;
 term2str t;
if (term2str t) = 
"-27 * x ^^^ 3 + -108 * x ^^^ 2 * y + -144 * x * y ^^^ 2 + -64 * y ^^^ 3"
then ()
else raise error "poly.sml: diff.behav. in make_polynomial";

(*Schalk I p.62 No.242c*)
 val t = str2term
 "x^^^(-4)*(x^^^(-4)*y^^^(-2))^^^(-1)*y^^^(-2)";
 val Some (t,_) = rewrite_set_ thy false make_polynomial t;
 term2str t;
if (term2str t) = 
"1"
then ()
else raise error "poly.sml: diff.behav. in make_polynomial";

(*Schalk I p.60 No.209a*)
 val t = str2term
 "a^^^(7-x) * a^^^x";
 val Some (t,_) = rewrite_set_ thy false make_polynomial t;
 term2str t;
if (term2str t) = 
"a ^^^ 7"
then ()
else raise error "poly.sml: diff.behav. in make_polynomial";

(*Schalk I p.60 No.209d*)
 val t = str2term
     "d^^^x * d^^^(x+1) * d^^^(2 - 2*x)";
 val Some (t,_) = rewrite_set_ thy false make_polynomial t;
 term2str t;
if (term2str t) = 
"d ^^^ 3"
then ()
else raise error "poly.sml: diff.behav. in make_polynomial";


(*---------------------------------------------------------------------*)
(*------------------ Bsple bei denen es Probleme gibt------------------*)
(*---------------------------------------------------------------------*)

(*Schalk I p.64 No.303*)
 val t = str2term
 "(a + 2*b)*(a^^^2 + 4*b^^^2)*(a - 2*b) - (a - 6*b)*(a^^^2 + 36*b^^^2)*(a + 6*b)";
 val Some (t,_) = rewrite_set_ thy false make_polynomial t;
 term2str t;
"1280 * b ^^^ 4";
(* Richtig - aber Binomische Formel wurde nicht verwendet! *)


(*--------------------------------------------------------------------*)
(*----------------------- Eigene Beispiele ---------------------------*)
(*--------------------------------------------------------------------*)

val t = str2term "a^^^2*a^^^(-2)";
 val Some (t,_) = rewrite_set_ thy false make_polynomial t;
 term2str t;
if (term2str t) = 
"1"
then ()
else raise error "poly.sml: diff.behav. in make_polynomial";

val t = str2term "a + a + a";
 val Some (t,_) = rewrite_set_ thy false make_polynomial t;
 term2str t;
if (term2str t) = 
"3 * a"
then ()
else raise error "poly.sml: diff.behav. in make_polynomial";

val t = str2term "a + b + b + b";
 val Some (t,_) = rewrite_set_ thy false make_polynomial t;
 term2str t;
if (term2str t) = 
"a + 3 * b"
then ()
else raise error "poly.sml: diff.behav. in make_polynomial";

val t = str2term "a^^^2*b*b^^^(-1)";
 val Some (t,_) = rewrite_set_ thy false make_polynomial t;
 term2str t;
if (term2str t) = 
"a ^^^ 2"
then ()
else raise error "poly.sml: diff.behav. in make_polynomial";

val t = str2term "a^^^2*a^^^(-2)";
 val Some (t,_) = rewrite_set_ thy false make_polynomial t;
 term2str t;
if (term2str t) = 
"1"
then ()
else raise error "poly.sml: diff.behav. in make_polynomial";

val t = str2term "b + a - b";
 val Some (t,_) = rewrite_set_ thy false make_polynomial t;
 term2str t;
if (term2str t) = 
"a"
then ()
else raise error "poly.sml: diff.behav. in make_polynomial";

val t = (term_of o the o (parse thy)) "b * a * a";
val Some (t,_) = rewrite_set_ thy false make_polynomial t;
term2str t;
if (term2str t) = 
"a ^^^ 2 * b"
then ()
else raise error "poly.sml: diff.behav. in make_polynomial";

val t = str2term "(a^^^2)^^^3";
val Some (t,_) = rewrite_set_ thy false make_polynomial t;
term2str t;
if (term2str t) = 
"a ^^^ 6"
then ()
else raise error "poly.sml: diff.behav. in make_polynomial";

val t = str2term "x^^^2 * y^^^2 + x * x^^^2 * y";
val Some (t,_) = rewrite_set_ thy false make_polynomial t;
term2str t;
if (term2str t) = 
"x ^^^ 3 * y + x ^^^ 2 * y ^^^ 2"
then ()
else raise error "poly.sml: diff.behav. in make_polynomial";

val t = (term_of o the o (parse thy)) "a^^^2 * (-a)^^^2";
val Some (t,_) = rewrite_set_ thy false make_polynomial t;
term2str t;
if (term2str t) = 
"a ^^^ 4"
then ()
else raise error "poly.sml: diff.behav. in make_polynomial";

val t = str2term "a * b * b^^^(-1) + a";
val Some (t,_) = rewrite_set_ thy false make_polynomial t;
term2str t;
if (term2str t) = 
"2 * a"
then ()
else raise error "poly.sml: diff.behav. in make_polynomial";

val t = str2term "a*c*b^^^(2*n) + 3*a + 5*b^^^(2*n)*c*b";
 val Some (t,_) = rewrite_set_ thy false make_polynomial t;
 term2str t;
if (term2str t) = 
"3 * a + 5 * b ^^^ (1 + 2 * n) * c + a * b ^^^ (2 * n) * c"
then ()
else raise error "poly.sml: diff.behav. in make_polynomial";


(*MG.27.6.03 -------------vvv-: Verschachtelte Terme -----------*)

val t = str2term "(1 + (x*y*a) + x)^^^(1 + (x*y*a) + x)";
 val Some (t,_) = rewrite_set_ thy false make_polynomial t;
 term2str t;
if term2str t = "(1 + x + a * x * y) ^^^ (1 + x + a * x * y)"
 then () else raise error "poly.sml: diff.behav. in make_polynomial";

val t = str2term "(1 + x*(y*z)*zz)^^^(1 + x*(y*z)*zz)";
 val Some (t,_) = rewrite_set_ thy false make_polynomial t;
 term2str t;
if term2str t = "(1 + x * y * z * zz) ^^^ (1 + x * y * z * zz)"
 then () else raise error "poly.sml: diff.behav. in make_polynomial";


