(* use"library.sml";
   WN.22.10.99
   for both, math-engine and isa-98-1-HOL-plus
   however, functions closely related to original isabelle-98-1 functions
            are in isa-98-1-HOL-plus/rewrite-parse/library_G
*)

infix ~~~;
fun xs ~~~ ys =
    let fun aaa xys []        []        = xys
	  | aaa xys []        (y :: ys) = xys
	  | aaa xys (x :: xs) []        = xys
	  | aaa xys (x :: xs) (y :: ys) = aaa (xys @ [(x, y)]) xs ys
    in aaa [] xs ys end;
(*[1,2,3] ~~~ ["1","2","3"];
val it = [(1, "1"), (2, "2"), (3, "3")] : (int * string) list
> [1,2] ~~~ ["1","2","3"];
val it = [(1, "1"), (2, "2")] : (int * string) list
> [1,2,3] ~~~ ["1","2"];
val it = [(1, "1"), (2, "2")] : (int * string) list*)



fun gen_insI eq pr (x, xs) = 
    if gen_mem eq (x, xs) 
    then (writeln ("### occurs twice: "^(pr x)); xs) 
    else x :: xs;
fun gen_union eq pr (xs, []) = xs
  | gen_union eq pr ([], ys) = ys
  | gen_union eq pr (x :: xs, ys) = gen_union eq pr (xs, gen_ins eq (x, ys));

fun cons2 (f,g) x = (f x, g x); (*PL softwareparadigmen*)

fun nth _ []      = raise error "nth _ []"
  | nth 1 (x::_) = x
  | nth n (_::xs) = nth (n-1) xs;
(*WN050106 quick for test: doesn't check for exns*)
fun drop_nth ls (_, []) = ls
  | drop_nth ls (n, x :: xs) = 
      if n = 1 
      then ls @ xs
      else drop_nth (ls @ [x]) (n - 1, xs);
(*> drop_nth [] (3,[1,2,3,4,5]); 
val it = [1, 2, 4, 5] : int list
 > drop_nth [] (1,[1,2,3,4,5]); 
val it = [2, 3, 4, 5] : int list
 > drop_nth [] (5,[1,2,3,4,5]); 
val it = [1, 2, 3, 4] : int list *)

fun and_ (b1,b2) = b1 andalso b2;(* ~/Design.98/ModelSpec.sml/library_G.sml *) 
fun or_ (b1,b2) = b1 orelse b2;
fun takerest (i, ls) = (rev o take) (length ls - i, rev ls);
fun pair2tri ((a,b),c) = (a,b,c);
fun fst3 (a,_,_) = a;
fun snd3 (_,b,_) = b;
fun thd3 (_,_,c) = c;

fun skip_blanks strl = 
  let 
    fun skip strl []        = strl
      | skip strl (" "::ss) = skip strl ss
      | skip strl ( s ::ss) = skip (strl @ [s]) ss
  in skip [] strl end;



fun de_quote str =
  let fun scan ss' [] = ss'
	| scan ss' ("\""::ss) = scan ss' ss
	| scan ss' (s::ss) = scan (ss' @ [s]) ss;
  in (implode o (scan []) o explode) str end;
(*> de_esc "\"d_d ?bdv (?u + ?v) = d_d ?bdv ?u + d_d ?bdv ?v\"";
val it = "d_d ?bdv (?u + ?v) = d_d ?bdv ?u + d_d ?bdv ?v" : string*)



(* conversions to (quoted) strings 
   FIXME: rename *2str --> *2strq (quoted elems) 
             now *2str' (elems NOT quoted) instead of *2str *)

val commas = space_implode ",";

fun strs2str strl = "[" ^ (commas (map quote strl)) ^ "]";
(*> val str = strs2str ["123","asd"]; writeln str;
val it = "[\"123\", \"asd\"]" : string
"123", "asd"] *)
fun strs2str' strl = "[" ^ (commas strl) ^ "]";
fun list2str strl = "[" ^ (commas strl) ^ "]";
(*> val str = list2str ["123","asd"]; writeln str;
val str = "[123, asd]" : string
[123, asd] *)
fun spair2str (s1,s2) =   "(" ^ (quote s1) ^ ", " ^ (quote s2) ^ ")";
fun pair2str (s1,s2) =   "(" ^ s1 ^ ", " ^ s2 ^ ")";
(*16.11.00
fun subs2str (subs:(string * string) list) = 
  (list2str o (map pair2str)) subs;*)
fun subs2str (subs: string list) = list2str  subs;
(*> val sss = ["(bdv,x)","(err,#0)"];
> subs2str sss;
val it = "[(bdv,x),(err,#0)]" : string*)
fun subs2str' (subs:(string * string) list) = (*12.12.99???*)
  (list2str o (map pair2str)) subs;
(*> val subs = subs2str [("bdv","x")]; writeln subs;
val subs = "[(\"bdv\", \"x\")]" : string
[("bdv", "x")] *)
fun con2str land_lor = quote " &| ";
fun ints2str ints = (strs2str o (map string_of_int)) ints;
fun ints2str' ints = (strs2str' o (map string_of_int)) ints;


(* use"library.sml";
   *)


(*needed in Isa + ME*)
fun get_thy str = 
  let fun get strl []        = strl
	| get strl ("."::ss) = strl
	| get strl ( s ::ss) = get (strl @ [s]) ss
  in implode( get [] (explode str)) end;

fun strip_thy str =              (* ~/Design.98/ModelSpec.sml/declare.sml  *)
  let fun strip bdVar []        = implode (rev bdVar)
	| strip bdVar ("."::_ ) = implode (rev bdVar)
	| strip bdVar (c  ::cs) = strip (bdVar @[c]) cs
  in strip [] (rev(explode str)) end;
    
fun id_of (Var ((id,ix),_)) = if ix=0 then id else id^(string_of_int ix)
  | id_of (Free (id    ,_)) = id
  | id_of (Const(id    ,_)) = id
  | id_of _                 = ""; (* never such an identifier *)

fun ids_of t =
  let fun con ss (Const (s,_)) = s::ss
	| con ss (Free (s,_)) = s::ss
	| con ss (Abs (s,_,b)) = s::(con ss b)
	| con ss (t1 $ t2) = (con ss t1) @ (con ss t2)
	| con ss _ = ss
  in map strip_thy ((distinct o (con [])) t) end;
(*
> val t = (term_of o the o (parse thy))
  "solve_univar (R, [univar, equation], no_met) (a = b + #1) a";
> ids_of t;
["solve'_univar","Pair","R","Cons","univar","equation","Nil",...]*)


fun overwritel (al, []) = al
  | overwritel (al, b::bl) = overwritel (overwrite (al, b), bl);
(*> val aaa = [(1,11),(2,22),(3,33)];
> overwritel (aaa, [(2,2222),(4,4444)]);
val it = [(1,11),(2,2222),(3,33),(4,4444)] : (int * int) list*)

local
fun intsto1 0 = []
  | intsto1 n = (intsto1 (n-1)) @ [n]
in
fun intsto n  = if n < 0 then (raise error "intsto < 0") else intsto1 n
end;


type 'a stack = 'a list;
fun top ((x::xs):'a stack) = x
  | top _ = raise error "top called for empty list";
fun pop ((x::xs):'a stack) = xs:'a stack
  | pop _ = raise error "pop called for empty list";
fun push x (xs:'a stack) = x::xs:'a stack;


fun drop_last l = ((rev o tl o rev) l);

fun bool2str true = "true"
  | bool2str false = "false";

(*.take elements from b to e including both.*)
fun take_fromto from to l = 
    if from > to then raise LIST ("take_fromto from="^string_of_int from^
				  " > to="^string_of_int to)
    else drop (from - 1, take (to, l));
(*> take_fromto 3 5 [1,2,3,4,5,6,7];
val it = [3,4,5] : int list 
> take_fromto 3 3  [1,2,3,4,5,6,7];
val it = [3] : int list*)

(*get the string for stac from rule*)
fun assoc_calc ([], key) = raise error ("assoc_calc: '"^ key ^"' not found")
  | assoc_calc ((calc, (keyi, xi)) :: pairs, key) =
      if key = keyi then calc else assoc_calc (pairs, key);
fun assoc1 ([], key) = raise error ("assoc1 (for met.calc=): '"^ key ^"' not found")
  | assoc1 ((all as (keyi, _)) :: pairs, key) =
      if key = keyi then all else assoc1 (pairs, key);
